--
-- FastNightGui
-- V1.0.0.0
--
-- @author apuehri
-- @date 09/12/2018
--
-- Copyright (C) apuehri
-- V1.0.0.0 ..... LS19 first implementation

fnGui = {};

local fnGui_mt = Class(fnGui, ScreenElement);

function fnGui:new(target, custom_mt)
    local self = ScreenElement:new(target, fnGui_mt);
    self.returnScreenName = "";
    return self;	
end;

function fnGui:onOpen()
    fnGui:superClass().onOpen(self);
	FocusManager:setFocus(self.backButton);
end;

function fnGui:onClose()
    fnGui:superClass().onClose(self);
end;

function fnGui:onClickBack()
    fnGui:superClass().onClickBack(self);
	fastnight:updGui();
end;

function fnGui:onClickOk()
    fnGui:superClass().onClickOk(self);
	fastnight:settingsFromGui(self.sdh:getState(), self.sdm:getState(), self.dts:getState(), self.adts:getIsChecked(), self.snh:getState(), self.snm:getState(), self.nts:getState(), self.ants:getIsChecked(), self.shhe:getIsChecked());
    self:onClickBack();
end;

function fnGui:onIngameMenuHelpTextChanged(element)
end;

function fnGui:onCreateFnGuiHeader(element)
	element.text = g_i18n:getText('gui_fn_Setting');
end;

function fnGui:onCreateStartDayHour(element)
    self.sdh = element;
	element.labelElement.text = g_i18n:getText('gui_fn_StartDayHour');
	element.toolTipText = g_i18n:getText('gui_fn_StartDayHourToolTip');
    local hour = {};

    for i = 1, #fastnight.hourSteps, 1 do
        hour[i] = ""..tostring(fastnight.hourSteps[i]).. " h";
    end;
    element:setTexts(hour);
end;

function fnGui:onCreateStartDayMinute(element)
    self.sdm = element;
    element.labelElement.text = g_i18n:getText('gui_fn_StartDayMinute');
	element.toolTipText = g_i18n:getText('gui_fn_StartDayMinuteToolTip');
	local minute = {};

    for i = 1, #fastnight.minuteSteps, 1 do
        minute[i] = ""..tostring(fastnight.minuteSteps[i]).. " m";
    end;
    element:setTexts(minute);
end;

function fnGui:onCreateDayTimeScale(element)
    self.dts = element;
	element.labelElement.text = g_i18n:getText('gui_fn_DayTimeScale');
	element.toolTipText = g_i18n:getText('gui_fn_DayTimeScaleToolTip');
    local timeScale = {};

    for i = 1, #fastnight.timeScaling, 1 do
        timeScale[i] = ""..tostring(fastnight.timeScaling[i]).. "x";
    end;
    element:setTexts(timeScale);
end;

function fnGui:onCreateAutoDayTimeScale(element)
	self.adts = element;
	element.labelElement.text = g_i18n:getText('gui_fn_AutoDayTimeScale');
	element.toolTipText = g_i18n:getText('gui_fn_AutoDayTimeScaleToolTip');
end;

function fnGui:onCreateShowHelp(element)
	self.shhe = element;
	element.labelElement.text = g_i18n:getText('gui_fn_ShowHelp');
	element.toolTipText = g_i18n:getText('gui_fn_ShowHelpToolTip');
end;

function fnGui:onCreateStartNightHour(element)
    self.snh = element;
	element.labelElement.text = g_i18n:getText('gui_fn_StartNightHour');
	element.toolTipText = g_i18n:getText('gui_fn_StartNightHourToolTip');	
    local hour = {};

    for i = 1, #fastnight.hourSteps, 1 do
        hour[i] = ""..tostring(fastnight.hourSteps[i]).. " h";
    end;
    element:setTexts(hour);
end;

function fnGui:onCreateStartNightMinute(element)
    self.snm = element;
	element.labelElement.text = g_i18n:getText('gui_fn_StartNightMinute');
	element.toolTipText = g_i18n:getText('gui_fn_StartNightMinuteToolTip');	
    local minute = {};

    for i = 1, #fastnight.minuteSteps, 1 do
        minute[i] = ""..tostring(fastnight.minuteSteps[i]).. " m";
    end;
    element:setTexts(minute);
end;

function fnGui:onCreateNightTimeScale(element)
    self.nts = element;
	element.labelElement.text = g_i18n:getText('gui_fn_NightTimeScale');
	element.toolTipText = g_i18n:getText('gui_fn_NightTimeScaleToolTip');	
    local timeScale = {};

    for i = 1, #fastnight.timeScaling, 1 do
        timeScale[i] = ""..tostring(fastnight.timeScaling[i]).. "x";
    end;
    element:setTexts(timeScale);
end;

function fnGui:onCreateAutoNightTimeScale(element)
	self.ants = element;
	element.labelElement.text = g_i18n:getText('gui_fn_AutoNightTimeScale');
	element.toolTipText = g_i18n:getText('gui_fn_AutoNightTimeScaleToolTip');		
end;

function fnGui:setStartDayHour(indexHour)
    self.sdh:setState(indexHour, false);
end;

function fnGui:setStartDayMinute(indexMinute)
    self.sdm:setState(indexMinute, false);
end;

function fnGui:setDayTimeScale(indexTimeScale)
    self.dts:setState(indexTimeScale, false);
end;

function fnGui:setAutoDayTimeScale(state)
    self.adts:setIsChecked(state);
end;

function fnGui:setShowHelp(state)
    self.shhe:setIsChecked(state);
end;

function fnGui:setStartNightHour(indexHour)
    self.snh:setState(indexHour, false);
end;

function fnGui:setStartNightMinute(indexMinute)
    self.snm:setState(indexMinute, false);
end;

function fnGui:setNightTimeScale(indexTimeScale)
    self.nts:setState(indexTimeScale, false);
end;

function fnGui:setAutoNightTimeScale(state)
    self.ants:setIsChecked(state);
end;